////////////////////////////////////////////////////////////////////////////////////////////////
//
//  SeriousShaderM.fx v0.20
//  f[^P
//  full.fx v1.2(͉P)x[Xɉ
//  : MipmapTextureAnisotropicFilter Furia
////////////////////////////////////////////////////////////////////////////////////////////////
// p[^錾

#define ShadowDarkness 0.625		// ZtVhE̍őÂ
#define UnderSkinDiffuse 0.2	// 牺U
#define ToonPower	1.5			// ëÂ
#define OverBright	1.1			// т댯Ė邭B

// eNX`Pobt@TCY
#define TEXBUFFWIDTH 768
#define TEXBUFFHEIGHT 768
#define TEXBUFFSIZE { TEXBUFFWIDTH, TEXBUFFHEIGHT }

// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float4x4 ProjMatrix				  : PROJECTION;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   MaterialToon      : TOONCOLOR;
float4   EdgeColor         : EDGECOLOR;
// CgF
float3   LightDiffuse      : DIFFUSE   < string Object = "Light"; >;
float3   LightAmbient      : AMBIENT   < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float4 DiffuseColor  = MaterialDiffuse  * float4(LightDiffuse, 1.0f);
static float3 AmbientColor  = saturate(MaterialAmbient  * LightAmbient + MaterialEmmisive);
static float3 SpecularColor = MaterialSpecular * LightSpecular;

bool     parthf;   // p[XyNeButO
bool     transp;   // tO
bool	 spadd;    // XtBA}bvZtO
#define SKII1    1500
#define SKII2    8000

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler OrgObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// eNX`̎pMipmap
texture UseMipmapObjectTexture : RENDERCOLORTARGET <
	int2 Dimensions = TEXBUFFSIZE;
	int MipLevels = 0;
>;

// eNX`̎ ٕtB^
sampler ObjTexSampler = sampler_state {
	texture = <UseMipmapObjectTexture>;
	MINFILTER = ANISOTROPIC;
	MAGFILTER = ANISOTROPIC;
	MIPFILTER = LINEAR;
	MAXANISOTROPY = 16;
};

// UseMipmapObjectTexturep[xobt@
texture UMOTDepth : RENDERDEPTHSTENCILTARGET <
	int2 Dimensions = TEXBUFFSIZE;
>;

const static float2 MipmapOffset = {0.5/TEXBUFFWIDTH, 0.5/TEXBUFFHEIGHT};
// _O^[Qbg̃NAl
float4 ClearColor = {0,0,0,0};
float ClearDepth  = 1;

////////////////////////////////////////////////////////////////////////////////////////////////
// eNX`Rs[
struct VS_OUT_COPYTEX {
    float4 Pos	: POSITION;
    float2 Tex	: TEXCOORD0;
};
VS_OUT_COPYTEX CopyTex_VS( float4 Pos : POSITION, float4 Tex : TEXCOORD0, uniform float2 TexOffset ){
	VS_OUT_COPYTEX o;
	o.Pos = Pos;
	o.Tex = Tex + TexOffset;
	return o;
}

float4 CopyTex_PS(float2 Tex: TEXCOORD0, uniform sampler TexSampler) : COLOR0 {
	return tex2D(TexSampler,Tex);
}

///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT {
    float4 Pos        : POSITION;    // ˉeϊW
    float2 Tex        : TEXCOORD1;   // eNX`
    float3 Normal     : TEXCOORD2;   // @
    float3 Eye        : TEXCOORD3;   // JƂ̑Έʒu
    float2 SpTex      : TEXCOORD4;	 // XtBA}bveNX`W
    float4 Color      : COLOR0;      // fBt[YF
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;
    
    // J_̃[hr[ˉeϊ
    Out.Pos = mul( Pos, WorldViewProjMatrix );
    
    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( Pos, WorldMatrix );
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
    
    // fBt[YF{ArGgF vZ
    Out.Color.rgb = AmbientColor;
    if ( !useToon ) {
        Out.Color.rgb += max(0,dot( Out.Normal, -LightDirection )) * DiffuseColor.rgb;
    }
    Out.Color.a = DiffuseColor.a;
    Out.Color = saturate( Out.Color );
    
    // eNX`W
    Out.Tex = Tex;
    
    if ( useSphereMap ) {
        // XtBA}bveNX`W
        float2 NormalWV = mul( Out.Normal, (float3x3)ViewMatrix );
        Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
        Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;
    }
    
    return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR0
{
    float4 Color = IN.Color;
    float4 ShadowColor = float4(AmbientColor, Color.a);  // e̐F
    if ( useTexture ) {
        // eNX`Kp
        float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        Color *= TexColor;
        ShadowColor *= TexColor;
    }
    if ( useSphereMap ) {
        // XtBA}bvKp
        float4 TexColor = tex2D(ObjSphareSampler,IN.SpTex);
        if(spadd) {
            Color.rgb += TexColor.rgb;
            ShadowColor.rgb += TexColor.rgb;
        } else {
            Color *= TexColor;
            ShadowColor *= TexColor;
        }
    }
    float comp = 1;
    if(useToon){
		comp = dot(IN.Normal,-LightDirection);
		ShadowColor.rgb *= pow(MaterialToon,ToonPower);
		Color.rgb*=OverBright;
	}

    comp*= (comp>=0) ? 1.0 : ShadowDarkness -1.0;
	Color = lerp(ShadowColor, Color, comp);

    // XyLKp
    // XyLFvZ
    float3 HalfVector = normalize( normalize(IN.Eye) + -LightDirection );
    float3 Specular = pow( max(0,dot( HalfVector, normalize(IN.Normal) )), SpecularPower ) * SpecularColor;
    Color.rgb += Specular;

	float d = pow(abs(dot(normalize(IN.Normal),normalize(IN.Eye))),UnderSkinDiffuse);
	Color.rgb += SpecularColor*(1.0-d);

    return Color;
}


// IuWFNg`peNjbN
// svȂ͍̂폜
#define BASIC_TEC_TEX(name, sphere, toon) \
	technique name < string MMDPass = "object"; bool UseTexture = true; bool UseSphereMap = sphere; bool UseToon = toon; \
		string Script = \
			"RenderColorTarget=UseMipmapObjectTexture;" \
				"RenderDepthStencilTarget=UMOTDepth;" \
					"ClearSetColor=ClearColor;" \
					"ClearSetDepth=ClearDepth;" \
					"Clear=Color;" \
					"Clear=Depth;" \
				"Pass=CreateMipmap;" \
			"RenderColorTarget=;" \
				"RenderDepthStencilTarget=;" \
				"Pass=DrawObject;" \
		; \
	> { \
		pass CreateMipmap < string Script= "Draw=Buffer;"; >{ \
			AlphaBlendEnable = false; \
			AlphaTestEnable = false; \
			ZEnable = false; \
			VertexShader = compile vs_2_0 CopyTex_VS(MipmapOffset); \
			PixelShader  = compile ps_2_0 CopyTex_PS(OrgObjTexSampler); \
		} \
		pass DrawObject { \
			VertexShader = compile vs_2_0 Basic_VS(true, sphere, toon); \
			PixelShader  = compile ps_2_0 Basic_PS(true, sphere, toon); \
		} \
	}
#define BASIC_TEC_NOTEX(name, sphere, toon) \
	technique name < string MMDPass = "object"; bool UseTexture = false; bool UseSphereMap = sphere; bool UseToon = toon; \
	> { \
		pass DrawObject { \
			VertexShader = compile vs_2_0 Basic_VS(false, sphere, toon); \
			PixelShader  = compile ps_2_0 Basic_PS(false, sphere, toon); \
		} \
	}

BASIC_TEC_TEX(MainTec0, false, false)
BASIC_TEC_TEX(MainTec1, true,  false)
BASIC_TEC_TEX(MainTec2, false, true)
BASIC_TEC_TEX(MainTec3, true,  true)

BASIC_TEC_NOTEX(MainTec4, false, false)
BASIC_TEC_NOTEX(MainTec5, true,  false)
BASIC_TEC_NOTEX(MainTec6, false, true)
BASIC_TEC_NOTEX(MainTec7, true,  true)


///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEONj

// VhEobt@̃TvB"register(s0)"Ȃ̂MMDs0gĂ邩
sampler DefSampler : register(s0);

struct BufferShadow_OUTPUT {
    float4 Pos      : POSITION;     // ˉeϊW
    float4 ZCalcTex : TEXCOORD0;    // Zl
    float2 Tex      : TEXCOORD1;    // eNX`
    float3 Normal   : TEXCOORD2;    // @
    float3 Eye      : TEXCOORD3;    // JƂ̑Έʒu
    float2 SpTex    : TEXCOORD4;	 // XtBA}bveNX`W
    float4 Color    : COLOR0;       // fBt[YF
};

// _VF[_
BufferShadow_OUTPUT BufferShadow_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    BufferShadow_OUTPUT Out = (BufferShadow_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    Out.Pos = mul(Pos,WorldViewProjMatrix);

    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( Pos, WorldMatrix );
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
	// Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul(Pos, LightWorldViewProjMatrix);

    // fBt[YF{ArGgF vZ
    Out.Color.rgb = AmbientColor;
    if ( !useToon ) {
        Out.Color.rgb += max(0,dot( Out.Normal, -LightDirection )) * DiffuseColor.rgb;
    }
    Out.Color.a = DiffuseColor.a;
    Out.Color = saturate( Out.Color );
    
    // eNX`W
    Out.Tex = Tex;
    
    if ( useSphereMap ) {
        // XtBA}bveNX`W
        float2 NormalWV = mul( Out.Normal, (float3x3)ViewMatrix );
        Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
        Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;
    }
    
    return Out;
}

// sNZVF[_
// VhE}bvႤ̂ŁAO`̎́A[hPƂB
float4 BufferShadow_PS(BufferShadow_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR
{
    float4 Color = IN.Color;
    float4 ShadowColor = float4(AmbientColor, Color.a);  // e̐F
    if ( useTexture ) {
        // eNX`Kp
        float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        Color *= TexColor;
        ShadowColor *= TexColor;
    }
    if ( useSphereMap ) {
        // XtBA}bvKp
        float4 TexColor = tex2D(ObjSphareSampler,IN.SpTex);
        if(spadd) {
            Color.rgb += TexColor.rgb;
            ShadowColor.rgb += TexColor.rgb;
        } else {
            Color *= TexColor;
            ShadowColor *= TexColor;
        }
    }
    float comp = 1;
    if(useToon){
		comp = dot(IN.Normal,-LightDirection);
		ShadowColor.rgb *= pow(MaterialToon,ToonPower);
		Color.rgb*=OverBright;
	}
    // eNX`Wɕϊ
    IN.ZCalcTex /= IN.ZCalcTex.w;
    float2 TransTexCoord;
    TransTexCoord.x = (1.0f + IN.ZCalcTex.x)*0.5f;
    TransTexCoord.y = (1.0f - IN.ZCalcTex.y)*0.5f;

	float shadow=1;
    if( !any( saturate(TransTexCoord) != TransTexCoord ) ) {
		shadow = 1 - saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r, 0) *
			(parthf ? SKII2*TransTexCoord.y // ZtVhE[h2
					: SKII1 // ZtVhE[h1
			) - 0.3);
    }
    comp*= (comp>=0) ? shadow*ShadowDarkness+1.0-ShadowDarkness : ShadowDarkness -1.0;
	Color = lerp(ShadowColor, Color, comp);

    // XyLKp
    // XyLFvZ
    float3 HalfVector = normalize( normalize(IN.Eye) + -LightDirection );
    float3 Specular = pow( max(0,dot( HalfVector, normalize(IN.Normal) )), SpecularPower ) * SpecularColor;
    Color.rgb += Specular*shadow;

	float d = pow(abs(dot(normalize(IN.Normal),normalize(IN.Eye))),UnderSkinDiffuse);
	Color.rgb += SpecularColor*(1.0-d);
    if( transp ) Color.a *= 0.5f;
    return Color;
}

// IuWFNg`peNjbN
// svȂ͍̂폜
#define SELFSHADOW_TEC_TEX(name, sphere, toon) \
	technique name < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = sphere; bool UseToon = toon; \
		string Script = \
			"RenderColorTarget=UseMipmapObjectTexture;" \
				"RenderDepthStencilTarget=UMOTDepth;" \
					"ClearSetColor=ClearColor;" \
					"ClearSetDepth=ClearDepth;" \
					"Clear=Color;" \
					"Clear=Depth;" \
				"Pass=CreateMipmap;" \
			"RenderColorTarget=;" \
				"RenderDepthStencilTarget=;" \
				"Pass=DrawObject;" \
		; \
	> { \
		pass CreateMipmap < string Script= "Draw=Buffer;"; >{ \
			AlphaBlendEnable = false; \
			AlphaTestEnable = false; \
			ZEnable = false; \
			VertexShader = compile vs_2_0 CopyTex_VS(MipmapOffset); \
			PixelShader  = compile ps_2_0 CopyTex_PS(OrgObjTexSampler); \
		} \
		pass DrawObject { \
			VertexShader = compile vs_3_0 BufferShadow_VS(true, sphere, toon); \
			PixelShader  = compile ps_3_0 BufferShadow_PS(true, sphere, toon); \
		} \
	}
#define SELFSHADOW_TEC_NOTEX(name, sphere, toon) \
	technique name < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = sphere; bool UseToon = toon; \
	> { \
		pass DrawObject { \
			VertexShader = compile vs_3_0 BufferShadow_VS(false, sphere, toon); \
			PixelShader  = compile ps_3_0 BufferShadow_PS(false, sphere, toon); \
		} \
	}

SELFSHADOW_TEC_TEX(BSTec0, false, false)
SELFSHADOW_TEC_TEX(BSTec1, true,  false)
SELFSHADOW_TEC_TEX(BSTec2, false, true)
SELFSHADOW_TEC_TEX(BSTec3, true,  true)

SELFSHADOW_TEC_NOTEX(BSTec4, false, false)
SELFSHADOW_TEC_NOTEX(BSTec5, true,  false)
SELFSHADOW_TEC_NOTEX(BSTec6, false, true)
SELFSHADOW_TEC_NOTEX(BSTec7, true,  true)

///////////////////////////////////////////////////////////////////////////////////////////////
